#include <stdio.h>
#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>

void die(char *msg) {
	fprintf(stderr, "envuidgid: %s\n", msg);
	exit(111);
}

int main(int argc, char **argv) {
	struct passwd *p;
#define SIZE 40
	char buf[SIZE];

	if (argc < 3)
		die("usage: envuidgid account command ...");

	p = getpwnam(argv[1]);
	if (!p)
		die("no such account");
	snprintf(buf, SIZE, "%d", p->pw_uid);
	if (setenv("UID", buf, 1) < 0)
		die("unable to set UID");
	snprintf(buf, SIZE, "%d", p->pw_gid);
	if (setenv("GID", buf, 1) < 0)
		die("unable to set GID");

	execvp(argv[2], &argv[2]);
	die("unable to exec");

	return 0; /* NOTREACHED */
}

