#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

void die(char *msg) {
	fprintf(stderr, "svok: %s\n", msg);
	exit(111);
}

int main(int argc, char **argv) {
	int fd;

	if (argc < 2)
		die("usage: svok service");

	if (chdir(argv[1]) < 0)
		die("unable to chdir to service dir");

	fd = open("supervise/control", O_WRONLY | O_NONBLOCK);
	if (fd < 0) {
		if (errno == ENXIO || errno == ENOENT)
			return 100;
		die("unable to open control pipe");
	}

	return 0;
}

