#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include "svstat.h"

#define FAIL(msg) { \
	printf("%s\n", msg); \
	continue; \
	}

int main(int argc, char **argv) {
	int fd, i, cwd;

	cwd = open(".", O_RDONLY);
	if (cwd < 0) {
		fprintf(stderr, "svstat: unable to open current directory\n");
		return 111;
	}
		
	for (i = 1; i < argc; i++) {
		struct svstat s;
		int rc;

		printf("%s: ", argv[i]);

		if (fchdir(cwd) < 0)
			FAIL("unable to chdir to original dir");
		if (chdir(argv[i]) < 0)
			FAIL("unable to chdir to service dir");

		fd = open("supervise/status", O_RDONLY);
		if (fd < 0) {
			FAIL("unable to open supervise/status");
		}
		rc = read(fd, &s, sizeof s);
		close(fd);
		if (rc < 0)
			FAIL("unable to read supervise/status");

		printf("%s (pid %d)", s.up ? "up" : "down", s.pid);
		if (s.up) {
			printf(" %ld seconds\n", time(NULL) - s.starttime);
		} else {
			printf("\n");
		}
	}

	close(cwd);

	return 0;
}

